//END USER CLASS
#ifndef ENDUSER_H
#define ENDUSER_H
#include "headerFiles.hpp"
#include "Utility.hpp"
#include "EnergySystem.hpp"

namespace decomposition
{

class EndUser
{
private:

	EnergySystem* linkToSystem;

	int numScen,numTimeSteps;

	vector<Utility*> inputUtilities;
	vector<Utility*> importUtilities;

	map<Utility*,vector<vector<Constraints>> > demandMap;
	
public:
	friend EnergySystem;
	friend Utility;

	EndUser(EnergySystem* enrg);

	void addUtilityDemand(Utility* utilityType, vector<vector<double>>* input);//imports user demand from uncertain parameter object, adds value to demandMap with constriants
	
	void addUtilitySource(Utility* utilityType); //imports energy from given utility source/type, e.g. electricity

	void setUtilityImportConstraint(Utility* utilityType);

	void getUtilityExport(vector<Objective>& objectiveFunction);
	void getUtilityImport(vector<Objective>& objectiveFunction);

};

}


#endif