#include "EnergySystem.hpp"

namespace decomposition
{

EnergySystem::EnergySystem(int scen, int time) : numScen{scen}, numTimeSteps{time}
	{
		 numUncertainParams=0;
		 numSources=0;
		 numConverters=0;
		 numUtilities=0;
		 numUsers=0;

		 varcount=-1;
		 concount=-1;
	};

void EnergySystem::importProbabilities(string filePath, vector<double>& prob)
	{
		//Scenario probabilities from csv to program     
	    int it_line=0;   
		int it_cell=0;
	    ifstream file;   
	    string filepath;
	    string cell;     
	    string line;
		file.open(filePath);
		bool printFile{false};
		if (!file.is_open())
		{
		    cout<<"Error opening file for probabilities"<<endl;
		
		}
		while(getline(file, line))
		{
			string comma(",");
		    if(printFile){ cout<<line<<endl;}
		    if(it_line!=0)
		    {
		        stringstream ss(line);
		        while (getline(ss,cell,';'))
		        {
		            if(it_cell == 1)
		            {
		            	if(cell.find(comma)!=string::npos)
		            	{
		                	probabilities.push_back(stod(cell.replace(cell.find(comma),comma.length(),".")));
		          		}
		                else
		                {
		                	probabilities.push_back(stod(cell));
		                }
		            }
		            it_cell++;
		        }
		    }
		    it_line++;
		    it_cell=0;
		    
		}
		file.close();
		if (file.is_open())
		{
		    cout<<"Error closing file for probabilities"<<endl;
		  
		}
		for(int h=0;h<numScen;++h)
		{
			prob.push_back(probabilities[h]);
		}
	};


}