//ENERGY SYSTEM CLASS 
#ifndef ENERGYSYSTEM_H
#define ENERGYSYSTEM_H
#include "headerFiles.hpp"
//#include "EndUser.hpp"

namespace decomposition
{
	class EnergySystem
{
private:

	int numScen, numTimeSteps;

	int numUncertainParams, numSources, numConverters, numUtilities, numUsers; //keep track of objects included in the system


	int varcount; //variable count, GOSSIP essential
	int concount; //constraints count, GOSSIP essential
	vector<double> probabilities;//vector with numScen probabilities, should always sum up to 1

public:

	char clabel[70]; //label for GOSSIP variables, GOSSIP essential


	EnergySystem(int scen, int time); //constructor, initialises renewablesProduced, nonRenewablesProduced,importedFromGrid;
	void importProbabilities(string filePath, vector<double> & prob); //import probabilities from textfile and add to weight vector in main file

	int getNumScen(){return numScen;};
	int getNumTimeSteps(){return numTimeSteps;};

	//inline functions to increment variable, constraint and object counts
	int addVariable(){++varcount; return varcount;};
	int addConstraint(){++concount; return concount;};

};

}
#endif
