#include "ObjectiveFunc.hpp"


namespace decomposition
{
	ObjectiveFunction::ObjectiveFunction(EnergySystem* enrg, double setBudget=100000000): numScen{enrg->getNumScen()}, numTimeSteps{enrg->getNumTimeSteps()}, linkToSystem{enrg}, budget{setBudget}
	{
		objFunc.resize(numScen);
		budgetCon.resize(numScen);
		for(int h=0;h<numScen;++h)
		{
			objFunc[h]=0;
			budgetCon[h]=-budget;
		};
	};


	void ObjectiveFunction::addOPEX(EndUser* user)
	{
		user->getUtilityExport(objFunc);
		user->getUtilityImport(objFunc);
	};

	void ObjectiveFunction::addCAPEX(Conversion* technology)
	{
		technology->addCAPEX(objFunc, budgetCon);
	};

	void ObjectiveFunction::setObjective()
	{
		for(int h=0;h<numScen;++h)
		{
			objFunc[h].setDependentVariable(linkToSystem->addConstraint(),compgraph::OBJ,true,h+1);
			budgetCon[h].setDependentVariable(linkToSystem->addConstraint(),compgraph::LEQ,true,h+1);
		};
	};
	
};