//Objective class
#ifndef OBJECTIVEFUNC_H
#define OBJECTIVEFUNC_H
#include "headerFiles.hpp"
#include "EndUser.hpp"
#include "EnergySystem.hpp"

namespace decomposition
{
	class ObjectiveFunction
	{
	private:
		int numScen, numTimeSteps;

		EnergySystem* linkToSystem;

		double budget;
		vector<Constraints> budgetCon;

		vector<Objective> objFunc; //vector to store objective function, function to be minimized by default



	public:
		friend EnergySystem;

		ObjectiveFunction(EnergySystem* enrg, double setBudget=100000000);

		void addOPEX(EndUser* user);

		void addCAPEX(Conversion* technology);

		int getNumScen(){return numScen;};

		void setObjective(); //setting the objective function, minimization by default

	};



}

#endif