#include "UncertainParam.hpp"

namespace decomposition
{

UncertainParam::UncertainParam(string path, EnergySystem* enrg, bool print=false): filePath{path}, linkToSystem{enrg}, numScen{enrg->getNumScen()}, numTimeSteps{enrg->getNumTimeSteps()}
	{  
	    // initializing
	    int t=0;
	    int h=0;
	    int it_line=0;
	    int it_cell=0;
	    ifstream file;
	    string cell;
	    string line;

	    bool printFile{print};
	 
	    vector<vector<double>> temp(numTimeSteps,vector<double>(numScen));
	    
	    //uncertain parameter values from csv to program
	    file.open(filePath);
	    string comma(",");
	    if (!file.is_open())
	    {
	        cout<<"Error opening file at "<< filePath<<endl;
	    }
	    while(getline(file, line))
	    {
	        if (printFile){cout <<line<<endl;}
	        if(it_line!=1)
	        {
	            stringstream ss(line);
	            while (getline(ss,cell,';'))
	            {
	                
	                if(it_line==0 && it_cell==1)
	                {
	                   paramName=cell;
	                }
	                else if (it_line>1 && it_cell==0)
	                {
	                    t = stoi(cell);
	                }
	                else if(it_line>1 && it_cell>0 )
	                {
	                	if(cell.find(comma)!=string::npos)
	                	{
	                		temp[t-1][it_cell-1]=stod(cell.replace(cell.find(comma),comma.length(),","));
	                	}
	                	else
	                	{
	                    	temp[t-1][it_cell-1] = stod(cell);
	                    }
	                }
	                it_cell++;
	            }
	        }
	        it_line++;
	        it_cell=0;
	    }
	    file.close();
	    if (file.is_open())
	    {
	        cout<<"Error closing file at "<< filePath<<endl;
	     
	    };

	    output.resize(numTimeSteps);
	    for(int t=0;t<numTimeSteps;++t)
	    {
	    	output[t].resize(numScen);
	    	for(int h=0;h<numScen;++h)
	    	{
	    		output[t][h]=temp[t][h];
	    	};

	    };
	    cout<<"Imported uncertain parameter values from csv-file "<<filePath <<endl;
	};
}