//UNCERTAIN PARAM CLASS
#ifndef UNCERTAINPARAM_H
#define UNCERTAINPARAM_H
#include "headerFiles.hpp"
#include "EnergySystem.hpp"

namespace decomposition
{

class UncertainParam
{

private:

	int numScen,numTimeSteps;

	string paramName; //name of imported parameter scenario values, set by user
	string filePath; //filepath to text/csv/excel file with parameter scenario values, should be numScen x numTimeSteps values

	vector<vector<double>> output; //vector with outout directly importet from text/csv/excel file, dimensions numTimeSteps and numScen


public:
	friend EnergySystem;

	EnergySystem* linkToSystem; //linking parameter to main energy system


	UncertainParam(string path, EnergySystem* enrg, bool print=false); //constructor


	vector<vector<double>>* getOutput(){return &output;};
};
}
#endif