//UTILITY class
#ifndef UTILITY_H
#define UTILITY_H
#include "headerFiles.hpp"
#include "Conversion.hpp"
#include "EnergySystem.hpp"

namespace decomposition
{


class Utility
{
private:

	EnergySystem* linkToSystem;

	int numScen, numTimeSteps;

	vector<vector<vector<Variables>>*> inputSources;
	vector<double> inputFractions;

public:
	friend Conversion;
	friend EnergySystem;

	string name;
	bool uncertainPrice{false};
	double constImportPrice{300}, constFiT{70}, surplusFiT{0.5};
	vector<vector<double>> importPrice;

	
	vector<vector<Constraints>> producedCon;

	vector<vector<Variables>> exported;
	vector<vector<Variables>> imported;
	vector<vector<Variables>> surplus;


	Utility(vector<vector<double>>* price, EnergySystem* enrg, string utilityName); //constructor

	void addUtility(vector<vector<Variables>>* input, double fraction); //adding energy from conversion to this utility type, fraction specifies amount of 
																	// 

	vector<vector<Variables>>* getOutput(){return &exported;};
	vector<vector<Variables>>* getImportVariable(){return &imported;};

	Variables& getSurplus(int t, int h){return surplus[t][h];};
	Variables& getExport(int t, int h){return exported[t][h];};
	Variables& getImport(int t, int h){return imported[t][h];};

	void setFiT(double FiT){constFiT=FiT;};
	void setSurplusFiT(double FiT){surplusFiT=FiT;};

	
	void setUtilityExportConstraint();
	
};

}

#endif


